/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.utlib.spring.mock;

import java.util.ArrayList;
import java.util.List;

import jp.terasoluna.fw.dao.StoredProcedureDAO;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * StoredProcedureDAÕbNAbvNXB
 * 
 * P̎StoredProcedureDAO̎NXƂĐݒ肷B
 *
 */
public class MockStoredProcedureDAO implements StoredProcedureDAO {
    
    /**
     * OCX^XB
     */
    private static Log log = LogFactory.getLog(MockStoredProcedureDAO.class);
    
    /**
     * \bhXgB
     * NX̃\bhsxɁAɊi[B
     */
    private List<DAOParams> storedProcedureDAOParams = new ArrayList<DAOParams>();
    
    /**
     * \bhXg擾B
     *
     * @return \bhXg
     */
    public List<DAOParams> getStoredProcedureDAOParams() {
        return storedProcedureDAOParams;
    }

    /**
     * storedProcedureDAOParamsɊi[B
     * 
     * @param sqlID sSQLID
     * @param bindParams SQLɃoChli[IuWFNg
     */
    public void executeForObject(String sqlID, Object bindParams) {
        if (log.isDebugEnabled()) {
            log.debug("executeForObject Start.");
        }
        
        // i[
        DAOParams params = new DAOParams();
        params.setSqlID(sqlID);
        params.setBindParams(bindParams);
        
        // \bhi[
        params.setMethodName("executeForObject");
        
        // XgɊi[
        storedProcedureDAOParams.add(params);
        
        if (log.isDebugEnabled()) {
            log.debug("executeForObject End.");
        }
    }



}